using SushiBarContracts.BindingModels;
using SushiBarContracts.ViewModels;
using SushiBarDataModels.Models;
using System.ComponentModel.DataAnnotations;

namespace SushiBarDatabaseImplement.Models
{
    public class Client : IClientModel
    {
        public int Id { get; private set; }
        [Required]
        public string ClientFIO { get; private set; } = string.Empty;
        [Required]
        public string Email {  get; private set; } = string.Empty;
        [Required]
        public string Password { get; private set; } = string.Empty;

        public static Client? Create(ClientBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new()
            {
                Id = model.Id,
                ClientFIO = model.ClientFIO,
                Email = model.Email,
                Password = model.Password
            };
        }

        public void Update(ClientBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            ClientFIO = string.IsNullOrEmpty(model.ClientFIO) ? ClientFIO : model.ClientFIO;
            Email = string.IsNullOrEmpty(model.Email) ? Email : model.Email;
            Password = string.IsNullOrEmpty(model.Password) ? Password : model.Password;
        }
        public ClientViewModel GetViewModel => new()
        {
            Id = Id,
            ClientFIO = ClientFIO,
            Email = Email,
            Password = Password
        };
    }
}
